--- base/utils.c.orig	Tue Nov 13 04:27:20 2007
+++ base/utils.c	Wed Dec  5 01:26:56 2007
@@ -1942,7 +1942,7 @@
 /************************ DAEMON FUNCTIONS ************************/
 /******************************************************************/
 
-int daemon_init(void){
+int daemon_init(char *user){
 	pid_t pid=-1;
 	int pidno=0;
 	int lockfile=0;
@@ -1950,13 +1950,33 @@
 	char buf[256];
 	struct flock lock;
 	char *homedir=NULL;
+	struct passwd *pw=NULL;
 
 #ifdef RLIMIT_CORE
 	struct rlimit limit;
 #endif
 
+	/* see if this is a user name */
+	if(strspn(user,"0123456789")<strlen(user)){
+		pw=(struct passwd *)getpwnam(user);
+		if(pw!=NULL)
+			homedir=pw->pw_dir;
+		else
+			logit(NSLOG_RUNTIME_WARNING,TRUE,"Warning: Could not get passwd entry for '%s'",user);
+	}
+
+	/* else we were passed the UID */
+	else{
+		pw=(struct passwd *)getpwuid((uid_t)atoi(user));
+		if(pw!=NULL)
+			homedir=pw->pw_dir;
+		else
+			logit(NSLOG_RUNTIME_WARNING,TRUE,"Warning: Could not get passwd entry for '%s'",user);
+	}
+
 	/* change working directory. scuttle home if we're dumping core */
-	homedir=getenv("HOME");
+	if (homedir==NULL)
+		homedir=getenv("HOME");
 	if(daemon_dumps_core==TRUE && homedir!=NULL)
 		chdir(homedir);
 	else
--- base/nagios.c.orig	Fri Nov 23 21:24:50 2007
+++ base/nagios.c	Wed Dec  5 01:26:56 2007
@@ -723,7 +723,7 @@
 			/* enter daemon mode (unless we're restarting...) */
 			if(daemon_mode==TRUE && sigrestart==FALSE){
 
-				daemon_init();
+				daemon_init(nagios_user);
 
 				asprintf(&buffer,"Finished daemonizing... (New PID=%d)\n",(int)getpid());
 				write_to_all_logs(buffer,NSLOG_PROCESS_INFO);
--- include/nagios.h.orig	Sun Nov 11 07:09:09 2007
+++ include/nagios.h	Wed Dec  5 01:26:56 2007
@@ -482,7 +482,7 @@
 void init_timing_loop(void);                         		/* setup the initial scheduling queue */
 void setup_sighandler(void);                         		/* trap signals */
 void reset_sighandler(void);                         		/* reset signals to default action */
-int daemon_init(void);				     		/* switches to daemon mode */
+int daemon_init(char *);			     		/* switches to daemon mode */
 int drop_privileges(char *,char *);				/* drops privileges before startup */
 void display_scheduling_info(void);				/* displays service check scheduling information */
 
